"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ganache = require("ganache-cli");
class Sandbox {
    listen(port = 8545, host = '127.0.0.1') {
        return __awaiter(this, void 0, void 0, function* () {
            yield new Promise((resolve, reject) => {
                this.server = ganache.server();
                this.server.listen(port, host, (e) => e ? reject(e) : resolve());
            });
            return this;
        });
    }
    close() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.server) {
                this.server.close();
                this.server = null;
            }
            return this;
        });
    }
}
exports.Sandbox = Sandbox;
//# sourceMappingURL=sandbox.js.map